/* Zadatak 3:

*/

#include <stdio.h>

/* ========================================================================= */

    /* Funkcija provjera. */

    /* Skica algoritma.
       Zadani regex je [^a](d*)[0-5]+\1. Dakle, ucitani niz od TOCNO n
       znakova mora imati sljedeci oblik, da bio bio "dobar" (prepoznat):
       - na pocetku, prvi znak mora biti razlicit od 'a' (moze biti '2'
         pa treba paziti na broj dvica);
       - iza toga ide zagrada (prva grupacija), u kojoj mora biti
         NULA ili vise znakova 'd', tj. zagrada smije biti prazna;
       - zatim dolazi niz od JEDNE ili vise znamenki izmedju '0' i '5'
         (i tu treba paziti na broj dvica);
       - na kraju niza se mora ponoviti prva grupacija \1, tj. niz od
         NULA ili vise znakova 'd', ali ih mora biti tocno ISTI broj
         kao u zagradi.
       Jednostavni nacin za provjeru \1 na kraju niza je:
       - izbrojati d-ove u prvom bloku (iz zagrade) - taj broj pamtimo
         u brojacu br_d,
       - provjeriti da na kraju niza (iza znamenki) ima tocno br_d d-ova.
       Zadnji od njih je n-ti znak, a prvi onda mora imati redni broj
       n - br_d + 1.

       Bitna stvar (osim za prvi znak): KRAJ nekog od preostala 3 bloka
       prepoznajemo tako da smo ucitali:
       - ili tocno n znakova (vise ne smijemo),
       - ili prvi znak IZA tog bloka!
    */

int provjera(int n, int *p_br_2)
{
        /* Broj znamenki '2' u cijelom nizu. */
    int br_2 = 0;

        /* Ucitani znak. */
    char znak;
        /* Indeks petlje = redni broj ucitanog znaka. */
    int i;
        /* Broj d-ova u prvoj grupaciji (zagradi). */
    int br_d = 0;


        /* Prema regexu, niz mora imati barem 2 znaka. Ako je n = 1,
           odmah vratimo 0, bez ikakvog citanja. */
    if (n == 1) return 0;

        /* Ucitaj prvi znak. Ako je jednak 'a', niz nije dobar,
           odmah vracamo 0. Ako je jednak '2', povecaj br_2 za 1. */
    scanf("%c", &znak);
    if (znak == 'a')
        return 0;
    else if (znak == '2')
        ++br_2;

        /* Ucitaj blok od 0 ili vise znakova 'd' (prva grupacija).
           Zapamti broj ucitanih d-ova u br_d. */
        /* Sljedeca petlja cita bar jedan znak, jer je n >= 2. */
    for (i = 2; i <= n; ++i) {

            /* Ucitaj i-ti znak. */
        scanf("%c", &znak);

            /* Ako je znak jednak 'd', povecaj br_d za 1.
               U protivnom, prekini petlju, jer smo ucitali
               prvi znak IZA (d*). */
        if (znak == 'd') ++br_d;
        else break;
    }

        /* Nakon zavrsetka petlje, provjeri kako je petlja zavrsila.
             Ako je i > n, onda smo ucitali tocno n znakova i zadnji
           ucitani znak je 'd'. Niz sigurno nije dobar, jer nema
           bar jedne znamenke.
             U protivnom, za i <= n, zadnji ucitani znak nije 'd', jer
           je izlaz morao biti s break. Onda provjerimo je li taj znak
           znamenka izmedju '0' i '5'. Ako nije, niz nije dobar,
           jer mora imati bar jednu takvu znamenku. */
    if (i > n) return 0;
    if (znak < '0' || znak > '5') return 0;

        /* Ovdje imamo (bar) jednu znamenku izmedju '0' i '5'.
           Provjeri jos je li znak = '2'. Ako je, povecaj br_2 za 1. */
    if (znak == '2') ++br_2;

        /* Ovdje je i <= n i zadnji ucitani znak je i-ti po redu.
           Citanje treba nastaviti od i+1-og znaka.
             Uociti: Ako je i = n, onda vise nemamo sto citati i onda
           nema d-ova na kraju niza. Provjera je li br_d = 0 ide malo
           kasnije, nakon citanja preostalih znamenki (ako ih ima). */

        /* Sad citamo preostale znamenke - blok od 0 ili vise znakova
           izmedju '0' i '5' (prvu smo vec ucitali i provjerili). */

        /* Sljedeca petlja cita znakove pocev od i+1-og. Zato u
           inicijalizaciji petlje povecamo i za 1. Nakon toga, moze
           se dogoditi da je i > n, pa sljedeca petlja nece ucitati
           niti jedan znak. */
    for (++i; i <= n; ++i) {

            /* Ucitaj i-ti znak. */
        scanf("%c", &znak);

            /* Ako je znak znamenka izmedju '0' i '5', onda provjeri
               je li znak = '2' - ako je, povecaj br_2 za 1.
               U protivnom, prekini petlju, jer smo ucitali
               prvi znak IZA [0-5]+. */
        if ('0' <= znak && znak <= '5') {
            if (znak == '2') ++br_2;
        }
        else break;
    }

        /* Nakon zavrsetka petlje, provjeri kako je petlja zavrsila.
             Ako je i > n, onda smo ucitali tocno n znakova i zadnji
           ucitani znak je znamenka izmedju '0' i '5'. To znaci da
           NEMA d-ova na kraju niza (isto kao malo ranije). Niz je
           dobar ako i samo ako je br_d = 0 (prazna prva grupacija).
           Ako je br_d > 0, vrati 0.
             U protivnom, za i <= n, zadnji ucitani znak nije znamenka
           izmedju '0' i '5', jer je izlaz morao biti s break.
           Ako taj znak nije jednak 'd', onda niz sigurno nije dobar.
             Ako je jednak 'd', onda se do kraja niza mora nalaziti
           jos tocno br_d - 1 znakova 'd' (ili niz nije dobar).
           To znaci da je prvi (vec ucitani) 'd' morao biti znak s
           rednim brojem i = n - br_d + 1. U protivnom, niz nije dobar */
    if (i > n) {
        if (br_d > 0) return 0;
    }
    else {    /* i <= n. */
        if (znak != 'd') return 0;
        if (i != n - br_d + 1) return 0;

            /* Citaj preostale znakove do n-tog. Ako bilo koji od tih
               znakova nije 'd', niz nije dobar. */
        for (i = n - br_d + 2; i <= n; ++i) {

                /* Ucitaj i-ti znak. */
            scanf("%c", &znak);

                /* Ako znak nije jednak 'd', prekini petlju i vrati 0,
                   jer niz sigurno nije dobar. */
            if (znak != 'd') return 0;
        }
    }

        /* Ako smo stigli do ovdje, niz je dobar, jer se nigdje
           nismo vratili s return 0. Vrati broj znamenki '2' kroz
           varijabilni argument. */
    *p_br_2 = br_2;

        /* Vrati rezultat provjere. */
    return 1;
}
/* ========================================================================= */

    /* Glavni program za demo. */

int main(void)
{
        /* Broj znakova, rezultat funkcije, broj znamenki 2. */
    int n = 20, prepoznaje, br_2;

        /* Poziv funkcije provjera. */
    br_2 = -1;
    prepoznaje = provjera(n, &br_2);

        /* Ispis rezultata. */
    if (prepoznaje)
        printf(" Prepoznaje niz, broj znamenki 2 = %d\n", br_2);
    else
        printf(" Ne prepoznaje niz\n");

    return 0;
}
